###########################################################
#   setup 'stdrc_darwin.sh' - Bash shell		          #
#                                                         #
# Created by Keith Thorne, 8 July 2010                    #
#                                                         #
# DO NOT EDIT THIS FILE!                                  #
# This file is part of a production system.               #
###########################################################
# Changes to it effect everyone.  Please play nice        #
# and contact the CDS sys admin if you feel this file     #
# needs to be changed.                                    #
#                                                         #
#  $Id: stdrc_linux.sh 983 2010-08-17 17:16:42Z keith.thorne@LIGO.ORG $
###########################################################

# set location of setup scripts
setupscriptdir=${cfgbase}/${site}/${ifo}

# Get info on processor
# - proctype should be sparc, i386 or x86_64
proctype=`uname -m`

# Set some shell defaults
# - limit size of core dumps
ulimit -c 100000

# setup X-windows DISPLAY variable
if [ "$REMOTEHOST" ]; then
   if [ ! "$DISPLAY" ]; then
      export DISPLAY=$REMOTEHOST":0"
   fi
elif [ ! "$DISPLAY" ]; then
   export DISPLAY=unix:0
fi

# define useful functions for adding to paths
addpath()
{
#  addpath - add to PATH if not already there
    thispath=$1
    echo ${PATH} | egrep -i ${thispath} >&/dev/null
    if [ "$?" -ne 0 ]; then
        export PATH=${PATH}:${thispath}
    fi
}
prepath()
{
#  prepath - add first to PATH if not already there
    thispath=$1
    echo ${PATH} | egrep -i ${thispath} >&/dev/null
    if [ "$?" -ne 0 ]; then
        export PATH=${thispath}:${PATH}
    fi
}
addlib()
{
#  addlib - add to LD_LIBRARY_PATH if not already there
    thislib=$1
    echo ${LD_LIBRARY_PATH} | egrep -i ${thislib}: >&/dev/null
    if [ "$?" -ne 0 ]; then
        export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${thislib}
    fi
}
prelib()
{
#  prelib - add first to LD_LIBRARY_PATH if not already there
    thislib=$1
    echo ${LD_LIBRARY_PATH} | egrep -i ${thislib}: >&/dev/null
    if [ "$?" -ne 0 ]; then
        export LD_LIBRARY_PATH=${thislib}:${LD_LIBRARY_PATH}
    fi
}
addmatlab()
{
#  addmatlab - add first to MATLABPATH if not already there
    thismat=$1
    echo ${MATLABPATH} | egrep -i ${thismat}: >&/dev/null
    if [ "$?" -ne 0 ]; then
        export MATLABPATH=${thismat}:${MATLABPATH}
    fi
}
adddylib()
{
#  adddylib - add to DYLD_LIBRARY_PATH if not already there
    thislib=$1
    echo ${DYLD_LIBRARY_PATH} | egrep -i ${thislib}: >&/dev/null
    if [ "$?" -ne 0 ]; then
        export DYLD_LIBRARY_PATH=${DYLD_LIBRARY_PATH}:${thislib}
    fi
}
predylib()
{
#  predylib - add to DYLD_LIBRARY_PATH if not already there
    thislib=$1
    echo ${DYLD_LIBRARY_PATH} | egrep -i ${thislib}: >&/dev/null
    if [ "$?" -ne 0 ]; then
        export DYLD_LIBRARY_PATH=${thislib}:${DYLD_LIBRARY_PATH}
    fi
}

#
# Setup PATH - assume there
#
addpath /usr/bin
addpath /bin
# MacPorts
prepath /opt/local/bin
prepath /opt/local/sbin
#
# Add libraries we will need
# - First one handles a non-existent LD_LIBRARY_PATH
if [ "$LD_LIBRARY_PATH" ]; then
   addlib /usr/lib
else
   export LD_LIBRARY_PATH=/usr/lib
fi
addlib /lib
#  MacPorts
prelib /opt/local/lib

#  First determine OS_ARCH
#  - proctype should be x86_64 or i386
if [ "$proctype" == "x86_64" ]; then
    export OS_ARCH=darwin-x86_64
else
    export OS_ARCH=darwin-x86
fi
#
# set APPSROOT from here
export APPSROOT=${APPSBASEDIR}/${OS_ARCH}

# ** Setup EPICS/MEDM **
if [ -e ${APPSROOT}/epics/etc/epics-user-env.sh ] ; then
    source ${APPSROOT}/epics/etc/epics-user-env.sh
else
    echo "ERROR: No EPICS setup at $APPSROOT/epics/etc"
fi
# add Probe, MEDM Editor to MEDM exec list
if [ -z "${MEDM_EXEC_LIST}" ]; then
    export MEDM_EXEC_LIST="Probe;probe &P &:MEDM Editor;medm &A &"
else
    if [[ "${MEDM_EXEC_LIST}" != *"MEDM"* ]]; then 	
        export MEDM_EXEC_LIST="MEDM Editor;medm &A &:${MEDM_EXEC_LIST}"
    fi
    if [[ "${MEDM_EXEC_LIST}" != *"Probe"* ]]; then 	
        export MEDM_EXEC_LIST="Probe;probe &P &:${MEDM_EXEC_LIST}"
    fi
fi
export EPICS_DISPLAY_PATH=${CDSROOT}/medm
alias m0='cd ${CDSROOT}/medm'
alias mr='cd ${RTCDSROOT}/medm'
alias medm_a='medm -displayFont alias'
alias medm_f='medm -displayFont fixed'
# sitemap - spawns MEDM, opening sitemap
alias sitemap_a='medm -x -displayFont alias ${CDSROOT}/medm/sitemap.adl &'
alias sitemap_f='medm -x -displayFont fixed ${CDSROOT}/medm/sitemap.adl &'
alias sitemap='medm -x -displayFont alias ${CDSROOT}/medm/sitemap.adl &'

# - fftw
if [ -e ${APPSROOT}/fftw/etc/fftw-user-env.sh ] ; then
    source ${APPSROOT}/fftw/etc/fftw-user-env.sh
else
    USING_SYSTEM_FFTW=1
    export USING_SYSTEM_FFTW
fi

# ** setup DataViewer **
if [[ -d "${APPSROOT}/dv" ]]; then
    prepath ${APPSROOT}/dv
fi
# ** setup grace if not local
if [[ ! -d "/usr/share/grace" ]]; then
    if [ -e source ${APPSROOT}/grace/etc/grace-user-env.sh ] ; then
        source ${APPSROOT}/grace/etc/grace-user-env.sh
    fi
else
    USING_SYSTEM_GRACE=1
    export USING_SYSTEM_GRACE
fi

# If ldas-tools present, use that
#    Otherwise use framecpp
if [[ -d "${APPSROOT}/ldas-tools/etc" ]]; then
    source ${APPSROOT}/ldas-tools/etc/ldas-tools-user-env.sh
elif [[ -e "${APPSROOT}/framecpp/etc/framecpp-user-env.sh" ]]; then
    source ${APPSROOT}/framecpp/etc/framecpp-user-env.sh
else
    USING_SYSTEM_FRAMECPP=1
    export USING_SYSTEM_FRAMECPP
fi
# - libframe
if [ -e ${APPSROOT}/libframe/etc/libframe-user-env.sh ] ; then
    source ${APPSROOT}/libframe/etc/libframe-user-env.sh
else
    USING_SYSTEM_LIBFRAME=1
    export USING_SYSTEM_LIBFRAME
fi
# - metaio
if [ -e ${APPSROOT}/metaio/etc/metaio-user-env.sh ] ; then
    source ${APPSROOT}/metaio/etc/metaio-user-env.sh
else
    USING_SYSTEM_METAIO=1
    export USING_SYSTEM_METAIO
fi
#  set up ROOT
if [ -e ${APPSROOT}/root/etc/root-user-env.sh ] ; then
    source ${APPSROOT}/root/etc/root-user-env.sh
else
    USING_SYSTEM_ROOT=1
    export USING_SYSTEM_ROOT
fi

# - set up GDS
if [ -e ${APPSROOT}/gds/etc/gds-user-env.sh ] ; then
    source ${APPSROOT}/gds/etc/gds-user-env.sh
else
    echo "ERROR: No GDS setup at $APPSROOT/gds/etc"
fi

# - set up python tools
if [ -e ${APPSROOT}/pytools/etc/pytools-user-env.sh ] ; then
    source ${APPSROOT}/pytools/etc/pytools-user-env.sh
fi
if [ -e ${APPSROOT}/cdsutils/etc/cdsutils-user-env.sh ] ; then
    source ${APPSROOT}/cdsutils/etc/cdsutils-user-env.sh
fi
if [ -e ${APPSROOT}/guardian/etc/guardian-user-env.sh ] ; then
    source ${APPSROOT}/guardian/etc/guardian-user-env.sh
fi

# ** setup ligotools **
if [ -e ${APPSROOT}/ligotools/bin/use_ligotools ] ; then
    eval `${APPSROOT}/ligotools/bin/use_ligotools`
else
    export LIGOTOOLS=${APPSROOT}/ligotools
    export TCLLIBPATH=${APPSROOT}/ligotools/lib/tconvert
    addpath ${APPSROOT}/ligotools/bin
fi

# -- MATLAB applications --
# ** setup MATLAB **
export MATLABROOT=${APPSROOT}/matlab
prepath ${MATLABROOT}/bin
# ** setup awgstream **
if [ -e ${APPSROOT}/awgstream/etc/awgstream-user-env.sh ] ; then
    source ${APPSROOT}/awgstream/etc/awgstream-user-env.sh
fi
# ** setup NDS2 client
if [ -e ${APPSROOT}/nds2-client/etc/nds2-client-user-env.sh ] ; then
    source ${APPSROOT}/nds2-client/etc/nds2-client-user-env.sh
else
    USING_SYSTEM_NDS2CLIENT=1
    export USING_SYSTEM_NDS2CLIENT
fi
# ** setup ligoDV  **
if [ -e ${APPSROOT}/ligodv/etc/ligodv-user-env.sh ] ; then
    source ${APPSROOT}/ligodv/etc/ligodv-user-env.sh
fi
# For Linux add location of utilities so read,dtterm is defined
if [ -d ${APPSROOT}/sunutils ] ; then
    addpath ${APPSROOT}/sunutils
fi

# ** setup mDV **
if [ -d ${APPSROOT}/mDV ] ; then
    addmatlab ${APPSROOT}/mDV
fi

# ** setup Scripts **
addpath ${CDSROOT}/scripts

